#pragma once
#include "PPgGeneral.h"
#include "PPgConnection.h"
#include "PPgServer.h"
#include "PPgDirectories.h"
#include "PPgFiles.h"
#include "PPgStats.h"
#include "PPgNotify.h"
#include "PPgIRC.h"
#include "PPgTweaks.h"
#include "PPgDisplay.h"
#include "PPgSecurity.h"
#include "PPgWebServer.h"
#include "PPgScheduler.h"
#include "PPgProxy.h"
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
#include "PPgDebug.h"
#endif
#include "PPgVirtual.h"	// [TPT] - itsonlyme: virtualDirs
// [TPT]
#include "PPgPhoenix1.h" // [TPT] - Two NEW Preference Panels
#include "PPgPhoenix.h"
#include "otherfunctions.h"
#include "ListBoxST.h"
#include "KCSideBannerWnd.h" 	//[TPT] - New Preferences Banner	
#include "ModeLess.h"

class CPreferencesDlg : public CModelessPropertySheet	// [TPT] - SLUGFILLER: modelessDialogs
{
	friend class CPreferencesPage; // [TPT] - SLUGFILLER: modelessDialogs

	DECLARE_DYNAMIC(CPreferencesDlg)
	
public:	
	CPreferencesDlg();
	virtual ~CPreferencesDlg();
	
	CPPgGeneral		m_wndGeneral;
	CPPgConnection	m_wndConnection;
	CPPgServer		m_wndServer;
	CPPgDirectories	m_wndDirectories;
	CPPgFiles		m_wndFiles;
	CPPgStats		m_wndStats;
	CPPgNotify		m_wndNotify;
	CPPgIRC			m_wndIRC;
	CPPgTweaks		m_wndTweaks;
	CPPgDisplay		m_wndDisplay;
	CPPgSecurity	m_wndSecurity;
	CPPgWebServer	m_wndWebServer;
	CPPgScheduler	m_wndScheduler;
	CPPgProxy		m_wndProxy;
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
	CPPgDebug		m_wndDebug;
#endif
	CPPgVirtual		m_wndVirtual;	// [TPT] - itsonlyme: virtualDirs
	// [TPT]
	CPPgPhoenix1	m_wndPhoenix1; // [TPT] - Two New Preference Panels
	CPPgPhoenix		m_wndPhoenix;

	CListBoxST		m_listbox;
	CButton			m_groupbox;
	CImageList		ImageList;
	int				m_iPrevPage;

	void Localize();

protected:
	UINT m_nActiveWnd;

	virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()
	afx_msg void OnDestroy();
	afx_msg void OnSelChanged();
	void UpdateSelection(CPropertyPage *page);	// [TPT] - SLUGFILLER: modelessDialogs
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
protected:
	CKCSideBannerWnd m_banner;	//[TPT] - New Preferences Banner	


};
